diff -ruN freeswan-1.9.orig/pluto/openssl.h freeswan-1.9/pluto/openssl.h
--- freeswan-1.9.orig/pluto/openssl.h	Wed Dec 31 19:00:00 1969
+++ freeswan-1.9/pluto/openssl.h	Wed May 16 10:57:20 2001
@@ -0,0 +1,101 @@
+#ifdef OPENSSL
+#ifndef OPENSSL_INC_H
+#define OPENSSL_INC_H
+
+#include <openssl/evp.h>
+#include <openssl/err.h>
+#include <openssl/pem.h>
+#include <openssl/x509.h>
+#include <openssl/x509v3.h>
+#include <openssl/safestack.h>
+
+#include <freeswan.h>
+
+#include "xmap.h"
+
+struct _x509_cert_node {
+  X509 *x;
+  struct _x509_cert_node *next;
+};
+
+typedef struct _x509_cert_node *X509_cert_list;
+
+typedef bool discrim_fn( X509 *x, STACK_OF(XMAP) *lu,
+			 struct payload_digest *const id_pld, bool strict);
+
+extern bool make_lookups(STACK_OF(XMAP) **lu, const char *spec );
+extern bool check_idtype_and_path( struct connection *c, const char *spec );
+
+extern void log_err( void );
+extern void load_cert_and_key( const char *cert, const char *key,
+			       X509 **x, EVP_PKEY **k );
+extern bool use_openssl( struct connection *c );
+extern STACK_OF(X509) *
+peer_cert_list( STACK_OF(XMAP) *lu,
+		int type,
+		X509 *cert, struct payload_digest *const id_pld,
+		bool strict );
+
+extern bool have_rsa_key( struct state *st );
+extern bool have_dss_key( struct state *st );
+extern bool have_rsa_keypair( struct state *st );
+extern bool have_elgamal_keypair( struct state *st );
+
+extern bool verify_certificate( X509 *x, STACK_OF(XMAP) *lu,
+				const char *path, bool strict );
+
+extern u_int32_t parse_options( const char *s );
+
+extern int DSA_sign_raw(unsigned char *dgst,int dlen,
+			unsigned char *sig, unsigned int *siglen, DSA *dsa);
+
+extern int DSA_verify_raw(const unsigned char *dgst,int dgst_len,
+			  unsigned char *sigbuf, int siglen, DSA *dsa);
+
+#define ERR_LIB_ELGAMAL 127
+
+#define ELGAMAL_F_ELGAMAL_PRIVATE_DECRYPT 100
+#define ELGAMAL_F_ELGAMAL_PUBLIC_ENCRYPT  101
+
+#define ELGAMAL_R_UNKNOWN_PADDING_TYPE      100
+#define ELGAMAL_R_DATA_GREATER_THAN_MOD_LEN 101
+#define ELGAMAL_R_PADDING_CHECK_FAILED      102
+
+#define ELGAMAL_PKCS1_PADDING RSA_PKCS1_PADDING
+#define ELGAMAL_PKCS1_OAEP_PADDING RSA_PKCS1_OAEP_PADDING
+#define ELGAMAL_NO_PADDING RSA_NO_PADDING
+
+#define ElGamalerr(f, r) ERR_PUT_error(ERR_LIB_ELGAMAL, (f), (r), ERR_file_name, __LINE__)
+
+void ERR_load_ElGamal_strings( void );
+int ElGamal_public_check( DSA *dsa );
+int ElGamal_public_encrypt( int flen, unsigned char *from,
+			    unsigned char *to,
+			    DSA *dsa, int padding );
+int ElGamal_private_decrypt( int flen, unsigned char *from,
+			     unsigned char *to,
+			     DSA *dsa, int padding );
+
+/* Function pointer pointing to an encryption routine */
+typedef void encryptor_fn( chunk_t *ch, struct state *c );
+
+extern bool valid_ciphertext_length( const u_int32_t len,
+				     struct connection *c );
+extern bool privkey_decrypt_chunk ( chunk_t *ch, struct state *c );
+extern bool pubkey_encrypt_chunk ( chunk_t *ch, struct state *c );
+
+/* get the other end's cert based */
+extern bool have_othercert( struct connection *c, int type );
+
+/* Macro to duplicate Private key. Used in unshare_connection_strings */
+#define EVP_PKEY_dup(pkey) \
+  (EVP_PKEY *)ASN1_dup((int (*)())i2d_PrivateKey, \
+  (char *(*)())d2i_AutoPrivateKey,(char *)pkey)
+
+/* convert EVP_PKEY to freeswan's RSA_public_key */
+extern const struct RSA_public_key *fs_RSA ( EVP_PKEY *evp_pkey );
+
+#endif
+#endif
+
+
diff -ruN freeswan-1.9.orig/pluto/openssl_defs.h freeswan-1.9/pluto/openssl_defs.h
--- freeswan-1.9.orig/pluto/openssl_defs.h	Wed Dec 31 19:00:00 1969
+++ freeswan-1.9/pluto/openssl_defs.h	Wed May 16 10:57:20 2001
@@ -0,0 +1,5 @@
+
+#define FILE_NAME_LIMIT 80
+#define PATH_NAME_LIMIT 256
+#define CERT_OPTIONS_LIMIT 128
+#define MAX_OTHER 2 /* only know about two type of certificate at the moment (RSA,DSA) */
diff -ruN freeswan-1.9.orig/pluto/packet.c freeswan-1.9/pluto/packet.c
--- freeswan-1.9.orig/pluto/packet.c	Fri Sep 15 05:09:26 2000
+++ freeswan-1.9/pluto/packet.c	Wed May 16 10:57:20 2001
@@ -12,7 +12,7 @@
  * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
  * for more details.
  *
- * RCSID $Id: packet.c,v 1.24 2000/09/15 09:09:26 dhr Exp $
+ * RCSID $Id: packet.c,v 1.26 2001/04/09 19:48:42 dhr Exp $
  */
 
 #include <stdio.h>
@@ -20,6 +20,8 @@
 #include <netinet/in.h>
 #include <string.h>
 
+#include <freeswan.h>
+
 #include "constants.h"
 #include "defs.h"
 #include "log.h"
@@ -639,7 +641,7 @@
 	/* put at least one * out */
 	for (;;)
 	{
-	    if (pre <= space)
+	  if (pre <= space)
 		break;
 	    *--pre = '*';
 	    if (p == NULL)
@@ -663,16 +665,16 @@
  */
 
 bool
-in_struct(void *struct_ptr, struct_desc *sd,
-    pb_stream *ins, pb_stream *obj_pbs)
+in_struct(void *struct_ptr, struct_desc *sd
+, pb_stream *ins, pb_stream *obj_pbs)
 {
-    char ugh[100];	/* arbitrary limit on diagnostic length */
+    char ugh[100];     /* arbitrary limit on diagnostic length */
     u_int8_t *cur = ins->cur;
 
     ugh[0] = '\0';
 
     if (ins->roof - cur < (ptrdiff_t)sd->size) {
-	snprintf(ugh, sizeof(ugh), "not enough room in input packet for %s", sd->name);
+      snprintf(ugh, sizeof(ugh), "not enough room in input packet for %s", sd->name);
     } else {
 	u_int8_t *roof = cur + sd->size;    /* may be changed by a length field */
 	u_int8_t *outp = struct_ptr;
@@ -687,8 +689,8 @@
 	    passert(outp - (cur - ins->cur) == struct_ptr);
 
 #if 0
-	    DBG(DBG_PARSING, DBG_log("%d %s",
-		(int) (cur - ins->cur), fp->name == NULL? "" : fp->name));
+	    DBG(DBG_PARSING, DBG_log("%d %s"
+		, (int) (cur - ins->cur), fp->name == NULL? "" : fp->name));
 #endif
 	    switch (fp->field_type) {
 	    case ft_mbz:	/* must be zero */
@@ -723,13 +725,13 @@
 			: immediate? sd->size : n + sd->size;
 
 		    if (len < sd->size) {
-			snprintf(ugh, sizeof(ugh),
-			    "%s of %s is smaller than minimum",
-			    fp->name, sd->name);
+                       snprintf(ugh, sizeof(ugh),
+                           "%s of %s is smaller than minimum",
+                           fp->name, sd->name);
 		    } else if (pbs_left(ins) < len) {
-			snprintf(ugh, sizeof(ugh),
-			    "%s of %s is larger than can fit",
-			    fp->name, sd->name);
+                       snprintf(ugh, sizeof(ugh),
+                           "%s of %s is larger than can fit",
+                           fp->name, sd->name);
 		    } else {
 			roof = ins->cur + len;
 		    }
@@ -741,18 +743,17 @@
 		    /* FALL THROUGH */
 		case ft_enum:	/* value from an enumeration */
 		    if (enum_name(fp->desc, n) == NULL) {
-			snprintf(ugh, sizeof(ugh),
-			    "%s of %s has an unknown value: %lu",
-			    fp->name, sd->name, (unsigned long)n);
+                       snprintf(ugh, sizeof(ugh),
+                           "bitset %s of %s has unknown member(s): %s",
+                           fp->name, sd->name, bitnamesof(fp->desc, n));
 		    }
 		    /* FALL THROUGH */
 		case ft_loose_enum:	/* value from an enumeration with only some names known */
 		    break;
 		case ft_set:	/* bits representing set */
 		    if (!testset(fp->desc, n)) {
-			snprintf(ugh, sizeof(ugh),
-			    "bitset %s of %s has unknown member(s): %s",
-			    fp->name, sd->name, bitnamesof(fp->desc, n));
+			snprintf(ugh, sizeof(ugh), "bitset %s of %s has unknown member(s): %s"
+			    , fp->name, sd->name, bitnamesof(fp->desc, n));
 		    }
 		    break;
 		default:
@@ -791,8 +792,8 @@
 		    obj_pbs->cur = cur;
 		}
 		ins->cur = roof;
-		DBG(DBG_PARSING,
-		    DBG_prefix_print_struct(ins, "parse ", struct_ptr, sd, TRUE));
+		DBG(DBG_PARSING
+		    , DBG_prefix_print_struct(ins, "parse ", struct_ptr, sd, TRUE));
 		return TRUE;
 
 	    default:
@@ -818,18 +819,18 @@
     {
 	if (bytes == NULL)
 	{
-	    DBG(DBG_PARSING,
-		DBG_log("skipping %u raw bytes of %s (%s)",
-		    (unsigned) len, ins->name, name);
-		DBG_dump(name, ins->cur, len));
+	    DBG(DBG_PARSING
+		, DBG_log("skipping %u raw bytes of %s (%s)"
+		    , (unsigned) len, ins->name, name);
+		  DBG_dump(name, ins->cur, len));
 	}
 	else
 	{
 	    memcpy(bytes, ins->cur, len);
-	    DBG(DBG_PARSING,
-		DBG_log("parsing %u raw bytes of %s into %s",
-		    (unsigned) len, ins->name, name);
-		DBG_dump(name, bytes, len));
+	    DBG(DBG_PARSING
+		, DBG_log("parsing %u raw bytes of %s into %s"
+		    , (unsigned) len, ins->name, name);
+		  DBG_dump(name, bytes, len));
 	}
 	ins->cur += len;
 	return TRUE;
@@ -851,20 +852,20 @@
  */
 
 bool
-out_struct(const void *struct_ptr, struct_desc *sd,
-    pb_stream *outs, pb_stream *obj_pbs)
+out_struct(const void *struct_ptr, struct_desc *sd
+, pb_stream *outs, pb_stream *obj_pbs)
 {
-    char ugh[100];	/* arbitrary limit on diagnostic length */
+    char ugh[100];     /* arbitrary limit on diagnostic length */
     const u_int8_t *inp = struct_ptr;
     u_int8_t *cur = outs->cur;
 
-    DBG(DBG_EMITTING,
-	DBG_prefix_print_struct(outs, "emit ", struct_ptr, sd, obj_pbs==NULL));
+    DBG(DBG_EMITTING
+	, DBG_prefix_print_struct(outs, "emit ", struct_ptr, sd, obj_pbs==NULL));
 
     ugh[0] = '\0';
     if (outs->roof - cur < (ptrdiff_t)sd->size) {
-	snprintf(ugh, sizeof(ugh)
-	    , "not enough room left in output packet to place %s", sd->name);
+	snprintf(ugh, sizeof(ugh), "not enough room left in output packet to place %s"
+	    , sd->name);
     } else {
 	bool immediate = FALSE;
 	pb_stream obj;
@@ -881,8 +882,8 @@
 	    passert(inp - (cur - outs->cur) == struct_ptr);
 
 #if 0
-	    DBG(DBG_EMITTING, DBG_log("%d %s",
-		(int) (cur - outs->cur), fp->name == NULL? "" : fp->name);
+	    DBG(DBG_EMITTING, DBG_log("%d %s"
+		, (int) (cur - outs->cur), fp->name == NULL? "" : fp->name);
 #endif
 	    switch (fp->field_type) {
 	    case ft_mbz:	/* must be zero */
@@ -934,18 +935,16 @@
 		    /* FALL THROUGH */
 		case ft_enum:	/* value from an enumeration */
 		    if (enum_name(fp->desc, n) == NULL) {
-			snprintf(ugh, sizeof(ugh),
-			    "%s of %s has an unknown value: %lu",
-			    fp->name, sd->name, (unsigned long)n);
+			snprintf(ugh, sizeof(ugh), "%s of %s has an unknown value: %lu"
+			    , fp->name, sd->name, (unsigned long)n);
 		    }
 		    /* FALL THROUGH */
 		case ft_loose_enum:	/* value from an enumeration with only some names known */
 		    break;
 		case ft_set:	/* bits representing set */
 		    if (!testset(fp->desc, n)) {
-			snprintf(ugh, sizeof(ugh),
-			    "bitset %s of %s has unknown member(s): %s",
-			    fp->name, sd->name, bitnamesof(fp->desc, n));
+			snprintf(ugh, sizeof(ugh), "bitset %s of %s has unknown member(s): %s"
+			    , fp->name, sd->name, bitnamesof(fp->desc, n));
 		    }
 		    break;
 		default:
@@ -1002,8 +1001,8 @@
 }
 
 bool
-out_generic(u_int8_t np, struct_desc *sd,
-    pb_stream *outs, pb_stream *obj_pbs)
+out_generic(u_int8_t np, struct_desc *sd
+, pb_stream *outs, pb_stream *obj_pbs)
 {
     struct isakmp_generic gen;
 
@@ -1013,8 +1012,8 @@
 }
 
 bool
-out_generic_raw(u_int8_t np, struct_desc *sd,
-    pb_stream *outs, void *bytes, size_t len, const char *name)
+out_generic_raw(u_int8_t np, struct_desc *sd
+, pb_stream *outs, void *bytes, size_t len, const char *name)
 {
     pb_stream pbs;
 
@@ -1030,16 +1029,16 @@
 {
     if (pbs_left(outs) < len)
     {
-	loglog(RC_LOG_SERIOUS, "not enough room left to place %lu bytes of %s in %s",
-	    (unsigned long) len, name, outs->name);
+	loglog(RC_LOG_SERIOUS, "not enough room left to place %lu bytes of %s in %s"
+	    , (unsigned long) len, name, outs->name);
 	return FALSE;
     }
     else
     {
-	DBG(DBG_EMITTING,
-	    DBG_log("emitting %u raw bytes of %s into %s",
-		(unsigned) len, name, outs->name);
-	    DBG_dump(name, bytes, len));
+	DBG(DBG_EMITTING
+	    , DBG_log("emitting %u raw bytes of %s into %s"
+		, (unsigned) len, name, outs->name);
+	      DBG_dump(name, bytes, len));
 	memcpy(outs->cur, bytes, len);
 	outs->cur += len;
 	return TRUE;
@@ -1056,8 +1055,8 @@
     }
     else
     {
-	DBG(DBG_EMITTING, DBG_log("emitting %u zero bytes of %s into %s",
-	    (unsigned) len, name, outs->name));
+	DBG(DBG_EMITTING, DBG_log("emitting %u zero bytes of %s into %s"
+	    , (unsigned) len, name, outs->name));
 	memset(outs->cur, 0x00, len);
 	outs->cur += len;
 	return TRUE;
@@ -1078,8 +1077,8 @@
 
 	if (pbs->lenfld_desc->field_type == ft_lv)
 	    len -= sizeof(struct isakmp_attribute);
-	DBG(DBG_EMITTING, DBG_log("emitting length of %s: %lu",
-	    pbs->name, (unsigned long) len));
+	DBG(DBG_EMITTING, DBG_log("emitting length of %s: %lu"
+	    , pbs->name, (unsigned long) len));
 	while (i-- != 0) {
 	    pbs->lenfld[i] = (u_int8_t)len;
 	    len >>= BITS_PER_BYTE;
diff -ruN freeswan-1.9.orig/pluto/preshared.c freeswan-1.9/pluto/preshared.c
--- freeswan-1.9.orig/pluto/preshared.c	Thu Feb 22 16:27:59 2001
+++ freeswan-1.9/pluto/preshared.c	Thu May 17 11:52:35 2001
@@ -11,7 +11,7 @@
  * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
  * for more details.
  *
- * RCSID $Id: preshared.c,v 1.42.2.2 2001/02/22 21:27:59 henry Exp $
+ * RCSID $Id: preshared.c,v 1.50 2001/04/09 19:48:42 dhr Exp $
  */
 
 #include <stdio.h>
@@ -203,10 +203,17 @@
     unsigned int best_match = 0;
     struct secret *best = NULL;
     struct secret *s;
-    struct id
-	*my_id = &c->this.id,
-	rw_id,
-	*his_id = &c->that.id;
+    struct id 
+       *my_id = &c->this.id,
+       rw_id,
+       *his_id = &c->that.id;
+
+    if (c->that.id.kind != ID_IPV4_ADDR || c->that.id.kind != ID_IPV6_ADDR) {
+      DBG(DBG_PARSING,
+      DBG_log("ID payload used is invalid: %s", enum_show(&ident_names, c->that.id.kind));
+      DBG_log("Make sure it's ID_IPV4_ADDR or ID_IPV6_ADDR when using PSK.");
+      );
+    }
 
     if (c->rw_state == rwcs_instance
     && (c->that.id.kind == ID_IPV4_ADDR || c->that.id.kind == ID_IPV6_ADDR)
@@ -545,7 +552,7 @@
     char buf[2048];	/* limit on size of binary representation of key */
     err_t ugh = NULL;
     err_t ugh_extra = "";
-    char ugh_space[100];	/* perhaps enough space */
+    char ugh_space[100];       /* perhaps enough space */
 
     if (*tok == '"' || *tok == '\'')
     {
@@ -573,10 +580,10 @@
 	    if (ugh != NULL)
 	    {
 		/* atobytes didn't like PSK data */
-		snprintf(ugh_space, sizeof(ugh_space)
-		    , "PSK data malformed (%s): ", ugh);
-		ugh = ugh_space;
-		ugh_extra = tok;
+                snprintf(ugh_space, sizeof(ugh_space)
+                    , "PSK data malformed (%s): ", ugh);
+                ugh = ugh_space;
+                ugh_extra = tok;
 	    }
 	    else
 	    {
@@ -613,8 +620,8 @@
 		}
 		else if (!tokeqword(p->name))
 		{
-		    ugh = p->name;
-		    ugh_extra = " keyword not found where expected in RSA key";
+                   ugh = p->name;
+                   ugh_extra = " keyword not found where expected in RSA key";
 		}
 		else if (!(shift()
 		&& (!tokeq(":") || shift())))	/* ignore optional ":" */
@@ -624,10 +631,10 @@
 		else if (NULL != (ugh = atobytes(tok, sfp->cur - tok, buf, sizeof(buf), &sz)))
 		{
 		    /* in RSA key, atobytes didn't like */
-		    snprintf(ugh_space, sizeof(ugh_space)
-			, "RSA data malformed (%s): ", ugh);
-		    ugh = ugh_space;
-		    ugh_extra = tok;
+                    snprintf(ugh_space, sizeof(ugh_space)
+                        , "RSA data malformed (%s): ", ugh);
+                    ugh = ugh_space;
+                    ugh_extra = tok;
 		}
 		else
 		{
@@ -667,14 +674,14 @@
     }
     else
     {
-	ugh = "unrecognized key format: ";
-	ugh_extra = tok;
+       ugh = "unrecognized key format: ";
+       ugh_extra = tok;
     }
 
     if (ugh != NULL)
     {
-	loglog(RC_LOG_SERIOUS, "\"%s\" line %d: %s%s"
-	    , sfp->filename, sfp->lino, ugh, ugh_extra);
+	loglog(RC_LOG_SERIOUS, "\"%s\" line %d: %s"
+	    , sfp->filename, sfp->lino, ugh);
     }
     else if (flushline("expected record boundary in key"))
     {
@@ -775,13 +782,13 @@
 
 		    if (tokeq("%any"))
 		    {
-			memset(&id, 0, sizeof(id));
+                        memset(&id, 0, sizeof(id));
 			id.kind = ID_IPV4_ADDR;
 			ugh = anyaddr(AF_INET, &id.ip_addr);
 		    }
 		    else if (tokeq("%any6"))
 		    {
-			memset(&id, 0, sizeof(id));
+                        memset(&id, 0, sizeof(id));
 			id.kind = ID_IPV6_ADDR;
 			ugh = anyaddr(AF_INET6, &id.ip_addr);
 		    }
@@ -797,7 +804,7 @@
 		    }
 		    else
 		    {
-			struct id *i = clone_id(&id);
+                        struct id *i = clone_id(&id);
 
 			i->next = s->ids;
 			s->ids = i;
diff -ruN freeswan-1.9.orig/pluto/preshared.h freeswan-1.9/pluto/preshared.h
--- freeswan-1.9.orig/pluto/preshared.h	Fri Aug 18 01:20:18 2000
+++ freeswan-1.9/pluto/preshared.h	Wed May 16 10:57:20 2001
@@ -29,7 +29,7 @@
 
 enum PrivateKeyKind {
     PPK_PSK,
-    /* PPK_DSS, */	/* not implemented */
+    /* PPK_DSS,     Still unsupported */
     PPK_RSA
 };
 
diff -ruN freeswan-1.9.orig/pluto/server.h freeswan-1.9/pluto/server.h
--- freeswan-1.9.orig/pluto/server.h	Tue Jan 23 18:09:31 2001
+++ freeswan-1.9/pluto/server.h	Wed May 16 10:57:20 2001
@@ -11,7 +11,7 @@
  * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
  * for more details.
  *
- * RCSID $Id: server.h,v 1.13 2001/01/23 23:09:31 dhr Exp $
+ * RCSID $Id: server.h,v 1.15 2001/04/06 20:30:08 dhr Exp $
  */
 
 extern struct sockaddr_un ctl_addr;	/* address of control (whack) socket */
